<?php
/*
Plugin Name: Automatic Newsletter
Plugin URI: http://craigfarnes.co.uk/
Description: Automaticly send a newsletter daily,weekly or monthly.
Author: Craig Farnes
Version: 2.1
Author URI: http://craigfarnes.co.uk/
*/
register_activation_hook(__FILE__,'autostart');


function autostart () {
   global $wpdb;
    if ( ! get_option('newstitle')){
      add_option('newstitle' , "");
    } else {
      update_option('newstitle' , "");
    }
	
	
	if ( ! get_option('newstext')){
      add_option('newstext' , "");
    } else {
      update_option('newstext' , "");
    }

   $table_name = "wp_newsdates";
   if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
      
      $sql = "CREATE TABLE " . $table_name . " (
	  nextdate TEXT NOT NULL
	  
	);";
	
      require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
      dbDelta($sql);
		
     }
	 $nextweek = date("W")+1;
		if($nextweek > 52) $nextweek=1;
		$wpdb->query("TRUNCATE wp_newsdates");
		$wpdb->insert('wp_newsdates',array('nextdate' => $nextweek), array( '%s' ));


	 $table_name = "wp_newsoptions";
  if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
      
      $sql = "CREATE TABLE " . $table_name . " (
	  id mediumint(9) NOT NULL AUTO_INCREMENT,
	  often text NOT NULL,
	  value text NOT NULL,
	  UNIQUE KEY id (id)
	);";
	
      require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
      dbDelta($sql);
		
     }
echo "hi";
                $wpdb->query("TRUNCATE wp_newsoptions");
                $wpdb->query('INSERT INTO wp_newsoptions  VALUES(1,"often","weekly")');
                $wpdb->query('INSERT INTO wp_newsoptions  VALUES(2,"recent","5")');
                $wpdb->query('INSERT INTO wp_newsoptions  VALUES(3,"subject","")');
                $wpdb->query('INSERT INTO wp_newsoptions  VALUES(4,"head","")');
		
	  
	  $table_name = "wp_newsletteremails";
  if($wpdb->get_var("show tables like '$table_name'") != $table_name) {
      
      $sql = "CREATE TABLE " . $table_name . " (
	  email text NOT NULL
	  
	);";
	
      require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
      dbDelta($sql);
     }
}

function sendnewsletter($number){
global $wpdb;
$wpdb->show_errors();
$posts = get_posts("numberposts=$number");
$homefind=$wpdb->get_row("SELECT * FROM wp_newsoptions WHERE id=4");
$head = $homefind->value;
$message= $head."<br>";
$homefind=$wpdb->get_row("SELECT * FROM wp_options WHERE option_id=3");
$home = $homefind->option_value;
$homefind=$wpdb->get_row("SELECT * FROM wp_options WHERE option_id=2");
$url = $homefind->option_value;
foreach($posts as $post){
	$title=$post->post_title;
	$content2=$post->post_content;
	$id=$post->ID;
	//$content2=substr($content,0,500);
    $message = $message."<b>".$title."</b><br />".$content2."<br /><a href='".$url."?p=".$id."'>See More..</a><br />";
}

// In case any of our lines are larger than 70 characters, we should use wordwrap()
$message = wordwrap($message, 70);

// Send
$emailsn = $wpdb->get_var("SELECT COUNT(*) FROM wp_newsletteremails");
//echo $emailsn;
$j=0;

$homefind=$wpdb->get_row("SELECT * FROM wp_newsoptions WHERE id=3");
$subject = $homefind->value;
//echo $home;
while($emailsn != $j){
$emails = $wpdb->get_row("SELECT * FROM wp_newsletteremails",OBJECT,$j);
$email = $emails->email;
//echo $email;
mail($email, $subject, $message,"To: The Receiver <$email>\n" .   
    "From: $home \n".
    "MIME-Version: 1.0\n" .   
    "Content-type: text/html; charset=iso-8859-1");
$j++;
}
}


add_action("widgets_init", array('newsletter', 'register'));
class newsletter {
  function control(){
    $data = get_option('newstitle');
    $data2 = get_option('newstext');
	
	?>
	<form action="" method="POST">
	Title:<input name="Title" value=<?php echo $data; ?>><br />
	Text Above Email Box:<textarea name="text"><?php echo $data2; ?></textarea>
	</form>
	<?php
	//print_r($_POST);
	if(isset($_POST['Title'])){
	//echo "ran";
	update_option('newstitle', $_POST['Title']);
	update_option('newstext', $_POST['text']);
	}
  }
  function widget($args){
  $data2 = get_option('newstext');
  $data = get_option('newstitle');
    echo $args['before_widget'];
    echo $args['before_title'] .$data. $args['after_title'];
	//print_r($data);
	echo $data2;
    ?>
	<form action="" method="POST">
Email:<input name="email"><br />
<input type="submit" name="submit">
</form>
<?php
if(isset($_POST['submit'])){
	global $wpdb;
	$wpdb->insert( 'wp_newsletteremails', array( 'email' => $_POST['email']), array('%s') );
	echo "Email Added, Thank you";
}
    echo $args['after_widget'];
  }
  function register(){
    register_sidebar_widget('Newsletter', array('newsletter', 'widget'));
    register_widget_control('Newsletter', array('newsletter', 'control'));
  }
}



add_action('admin_menu', 'autonewspage');
function autonewspage(){
	add_options_page('options-general.php','Automatic Newsletter Settings','administrator','autonews','autonewsdisplay');
}
function autonewsdisplay() {
global $wpdb;
$wpdb->show_errors();
$get = $wpdb->get_row("SELECT * FROM wp_newsoptions WHERE id=2");
$recent = $get->value;
$get = $wpdb->get_row("SELECT * FROM wp_newsoptions WHERE id=1");
$often = $get->value;
?>
<form action="" method="POST">
How often to send newsletters:
<select name="often">
<?php
if($often == "Daily"){
echo '<option value="Daily" selected="selected">Daily</option>';
}else{ 
echo '<option value="Daily">Daily</option>';
}
if($often == "weekly"){
echo '<option value="weekly" selected="selected">Weekly</option>';
}else{
echo '<option value="weekly">Weekly</option>';
}
if($often == "Monthly"){
echo '<option value="Monthly" selected="selected">Monthly</option>';
}else{
echo '<option value="Monthly">Monthly</option>';
}
?>

</select><br />
<input type="submit" name="often2" value="save"><br />
</form>
<form action="" method="POST">
Number of recent posts to email:<input value="<?php echo $recent; ?>" name="recent"><br />
<input type="submit" name="submit" value="Save" >
</form>
<form action="" method="POST">
<input type="submit" name="send" value="Send a Newsletter Now">
</form>
<?php
if(isset($_POST['often2'])){
	//$wpdb->query("TRUNCATE wp_newsoptions");
         $often=$_POST['often'];
         $wpdb->query("UPDATE wp_newsoptions SET value='$often' WHERE id= 1");
	
	
	
	$when = $wpdb->get_row("SELECT * FROM wp_newsoptions WHERE id=1");
	$number = $wpdb->get_row("SELECT * FROM wp_newsoptions WHERE id=2");
	$number = $number->value;
	$next = $wpdb->get_row("SELECT * FROM wp_newsdates");
	$next = $next->nextdate;
	$when=$_POST['often'];
	if($when=="Daily"){
		
			//add check if over days of the month etc
			$wpdb->query("TRUNCATE wp_newsdates");
			$nextday = date("j")+1;
			$month = date("n");
			switch ($month){
				case 1:
				$days=31;
				break;
				
				case 2:
				$days=28;
				break;
				
				case 3:
				$days=31;
				break;
				
				case 4:
				$days=30;
				break;
				
				case 5:
				$days=31;
				break;
				
				case 6:
				$days=30;
				break;
				
				case 7:
				$days=31;
				break;
				
				case 8:
				$days=31;
				break;
				
				case 9:
				$days=30;
				break;
				
				case 10:
				$days=31;
				break;
				
				case 11:
				$days=30;
				break;
				
				case 12:
				$days=31;
				break;
			}
			if($nextday > $days){
			$nextday = 1;
			}
			$wpdb->insert('wp_newsdates',array('nextdate' => $nextday), array( '%s' ));
			
		}
		
	
	if($when=="weekly"){
		//echo date("W");
		
		$nextweek = date("W")+1;
		if($nextweek > 52) $nextweek=1;
		$wpdb->query("TRUNCATE wp_newsdates");
		$wpdb->insert('wp_newsdates',array('nextdate' => $nextweek), array( '%s' ));
	}
	if($when=="Monthly"){
		
		$nextmonth = date("n")+1;
		if($nextmonth > 12) $nextmonth=1;
		$wpdb->query("TRUNCATE wp_newsdates");
		$wpdb->insert('wp_newsdates',array('nextdate' => $nextmonth), array( '%s' ));
	}
	
	
	echo '<meta http-equiv="refresh" content="1">';
	echo "Saved";
}
if(isset($_POST['submit'])){
	//$wpdb->query("TRUNCATE wp_newsoptions");
	$often=$_POST['recent'];
         $wpdb->query("UPDATE wp_newsoptions SET value='$often' WHERE id= 2");
	echo "Saved";
}
if(isset($_POST['send'])){
	sendnewsletter($recent);
	echo "Sent!";
}


echo "<h2>Email Management</h2>";
echo '<form action="" method="POST">';
echo '<select name="emails">'; 
$emailsn = $wpdb->get_var("SELECT COUNT(*) FROM wp_newsletteremails");
$j=0;
while($emailsn != $j){
$emails = $wpdb->get_row("SELECT * FROM wp_newsletteremails",OBJECT,$j);
$email = $emails->email;
echo "<option value=".$email.">".$email."</option>";
$j++;
}
echo "</select>";
echo '<input type="submit" name="remove" value="Remove">';
echo '</form>';
if(isset($_POST['remove'])){
	$wpdb->query("DELETE FROM wp_newsletteremails WHERE email='".$_POST['emails']."'");
	echo '<meta http-equiv="refresh" content="1">';
	echo "Removed";
}
?>
<form action="" method="POST">
Email:<input name="email2">
<input type="submit" name="add" value="Add Email">
</form>
<?php
if(isset($_POST['add'])){
	$wpdb->insert( 'wp_newsletteremails', array( 'email' => $_POST['email2']), array( '%s'));
	echo "Added";
	echo '<meta http-equiv="refresh" content="1">';
}
$get = $wpdb->get_row("SELECT * FROM wp_newsoptions WHERE id=3");
$subject = $get->value;
$get = $wpdb->get_row("SELECT * FROM wp_newsoptions WHERE id=4");
$head = $get->value;
?>
<h3>Newsletter Email Settings</h3><br />
<form action="" method="POST">
Subject:<input name="subject" value="<?php echo $subject; ?>"><br />
Header Text:<textarea name="header"><?php echo $head; ?></textarea><br />
<input type="Submit" name="save" value="Save">
</form>
<?php
if(isset($_POST['save'])){
	$subject = $_POST['subject'];
	$head = $_POST['header'];
	$wpdb->query("UPDATE wp_newsoptions SET value='$subject' WHERE id= 3");
	$wpdb->query("UPDATE wp_newsoptions SET value='$head' WHERE id= 4");
	echo "Saved";
	echo '<meta http-equiv="refresh" content="1">';
}
}
add_action( is_admin() ? 'admin_head' : 'wp_head', 'load_into_head212' ); 
function load_into_head212() {  
	global $wpdb;
	$wpdb->show_errors();
	$when = $wpdb->get_row("SELECT * FROM wp_newsoptions WHERE id=1");
	$number = $wpdb->get_row("SELECT * FROM wp_newsoptions WHERE id=2");
	$number = $number->value;
	$next = $wpdb->get_row("SELECT * FROM wp_newsdates");
	$next = $next->nextdate;
	$when=$when->value;
	if($when=="Daily"){
		if(date("j")>=$next){
			sendnewsletter($number);
			//add check if over days of the month etc
			$wpdb->query("TRUNCATE wp_newsdates");
			$nextday = date("j")+1;
			$month = date("n");
			switch ($month){
				case 1:
				$days=31;
				break;
				
				case 2:
				$days=28;
				break;
				
				case 3:
				$days=31;
				break;
				
				case 4:
				$days=30;
				break;
				
				case 5:
				$days=31;
				break;
				
				case 6:
				$days=30;
				break;
				
				case 7:
				$days=31;
				break;
				
				case 8:
				$days=31;
				break;
				
				case 9:
				$days=30;
				break;
				
				case 10:
				$days=31;
				break;
				
				case 11:
				$days=30;
				break;
				
				case 12:
				$days=31;
				break;
			}
			if($nextday > $days){
			$nextday = 1;
			}
			$wpdb->insert('wp_newsdates',array('nextdate' => $nextday), array( '%s' ));
		}
		}
	
	if($when=="weekly"){
		//echo date("W");
		if($next == date("W")){
			sendnewsletter($number);
		}
		$nextweek = date("W")+1;
		if($nextweek > 52) $nextweek=1;
		$wpdb->query("TRUNCATE wp_newsdates");
		$wpdb->insert('wp_newsdates',array('nextdate' => $nextweek), array( '%s' ));
	}
	if($when=="Monthly"){
		if($next == date("n")){
			sendnewsletter($number);
		}
		$nextmonth = date("n")+1;
		if($nextmonth > 12) $nextmonth=1;
		$wpdb->query("TRUNCATE wp_newsdates");
		$wpdb->insert('wp_newsdates',array('nextdate' => $nextmonth), array( '%s' ));
	}
}
?>